/*
 * GRfundecl.h
 * GR routine declarations
 *
 */

#ifndef GRFUNDECL_H
#define GRFUNDECL_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "std.h"
#include "dvstd.h"
#include "dvGR.h"
#include "GRtextarray.h"


/***
*** 
***/




/* GR/GRcolor.c */
BOOLPARAM GRs_color_table V_P_((COLOR_TABLE *color_table));
BOOLPARAM GRg_color_table V_P_((COLOR_TABLE **color_table));
BOOLPARAM GRg_real_color_tab V_P_((COLOR_TABLE **color_table));
BOOLPARAM GRappend_color V_P_((RGB_SPEC *rgb));
BOOLPARAM GRdrop_color V_P_((void));
BOOLPARAM GRs_index_color V_P_((int index, RGB_SPEC *rgb));
BOOLPARAM GRs_index_rw V_P_((int index, BOOLPARAM rw));
BOOLPARAM GRcolor V_P_((int color_table_index));
BOOLPARAM GRbackcolor V_P_((int index));
void GRSetColors V_P_((void));
void GRResetColors V_P_((void));
BOOLPARAM GRrgbtoindex V_P_((int r,  int g,  int b,  int *index));
BOOLPARAM GRindextorgb V_P_((int index,  int *r,  int *g,  int *b));
ULONG GRg_pixel V_P_((ULONG index));
BOOLPARAM GRpixeltorgb V_P_((ULONG pixel,  UBYTE *red,
	 UBYTE *green,  UBYTE *blue));

/***
*** 
***/




/* GR/GRcursor.c */
BOOLPARAM GRcr_record V_P_((FILE *file));
BOOLPARAM GRcr_grecord V_P_((FILE **file));
BOOLPARAM GRcr_playback V_P_((FILE *file));
BOOLPARAM GRcr_gplayback V_P_((FILE **file));
BOOLPARAM GRunlocate V_P_((int key, DV_POINT *location));
int GRlocate V_P_((DV_POINT *p));
BOOLPARAM GRcr_open_poll V_P_((void));
BOOLPARAM GRcr_close_poll V_P_((void));
BOOLPARAM GRcr_event V_P_((int new_eventflag,
	 int *current_eventflag));
BOOLPARAM GRcr_status V_P_((DV_BOOL *onoff,  DV_POINT *pt,
	 ADDRESS *raster));
BOOLPARAM GRcr_define V_P_((ADDRESS raster));
int GRcr_poll V_P_((DV_POINT *p));
BOOLPARAM GRwe_mask V_P_((ULONG mask, ULONG altmask));
BOOLPARAM GRwe_gmask V_P_((ULONG *mask,	ULONG *wmask));
BOOLPARAM GRwe_poll V_P_((int mode,  int source,  WINEVENT *we));
BOOLPARAM GRwe_state V_P_((WINEVENT *we));
BOOLPARAM GRwe_dispatch_event V_P_((WINEVENT *we));
BOOLPARAM GRwe_convert V_P_((ADDRESS event, WINEVENT *we));

/***
*** 
***/




/* GR/GR.c */
BOOLPARAM GRopen V_P_((char dev_name[], int *dev_num));
BOOLPARAM GRclose V_P_((int dev_num));
BOOLPARAM GRselect V_P_((int dev_num));
BOOLPARAM GRcurrent_dev V_P_((int *curr_device));
BOOLPARAM GRaspect_ratio V_P_((int *n, int *d));
BOOLPARAM GRdepth V_P_((int *depth));
BOOLPARAM GRflush V_P_((void));
BOOLPARAM GRend_frame V_P_((void));
BOOLPARAM GRvcs_to_scs V_P_((DV_POINT *input_p,  DV_POINT *screen_p));
BOOLPARAM GRscs_to_vcs V_P_((DV_POINT *input_p,  DV_POINT *virtual_p));
BOOLPARAM GRsetfio V_P_((char *devname,  FILE *inputfio,
	 FILE *outputfio));
BOOLPARAM GRsetlogfio V_P_((FILE *fio));
BOOLPARAM GRgetfio V_P_((char *devname,  FILE **inputfio,
	 FILE **outputfio));
BOOLPARAM GRgetlogfio V_P_((FILE **fio));
BOOLPARAM GRviewport V_P_((DV_POINT *llp, DV_POINT *urp));
BOOLPARAM GRg_viewport V_P_((DV_POINT *llp, DV_POINT *urp));
LONG GRmaskplanes V_P_((LONG mask));
BOOLPARAM GRreset V_P_((void));
BOOLPARAM GRset V_P_((ULONG i, ...));
BOOLPARAM GRget V_P_((ULONG i, ...));
BOOLPARAM GRopen_set V_P_((char dev_name[],  int *dev_num,  ...));
BOOLPARAM GRprint_start(ADDRESS pr_struct);
BOOLPARAM GRprint_end();
BOOLPARAM GRprint_reset();
ADDRESS GRprint_set(int first_arg, va_list argptr);
void GR_pr_toggle();

/***
*** 
***/




/* GR/GRIDSfrmt.c */
BOOLPARAM GRIDSformat V_P_((FILE *infile, FILE *outfile));

/* GR/GRblogplay.c */
BOOLPARAM GRblogplayback V_P_((FILE *logfile,  int device_map[]));

/* GR/GRcurve.c */
int GRcubprecision V_P_((int max_deviation));
int GRcubsize V_P_((register DV_POINT *a));
int GRcubpts V_P_((register DV_POINT a[4],  DV_POINT *ptbuf,  int bufsize));
void GRcubdraw V_P_((DV_POINT a[4],  int linepattern,  int linewidth));
void GRbeztocub V_P_((register DV_POINT *bez,  register DV_POINT *cub));
void GRcubtobez V_P_((register DV_POINT *cub,  register DV_POINT *bez));
void GRbezsplit V_P_((register DV_POINT *inbez,  register DV_POINT *outbez0,
	 register DV_POINT *outbez1));
void GRbsptocub V_P_((register DV_POINT *bsp,  register DV_POINT *cub));
int GRbspcubics V_P_((DV_POINT *cparray,  int numcps,  int end_conditions,
	 register DV_POINT (*cubics)[4]));
int GRbspdraw V_P_((DV_POINT *cps,  int numcps,  int end_conditions,
	 int linepattern,  int linewidth));

/* GR/GRdata.c */

/* GR/GRdevices.c */
BOOLPARAM GRisdevopen V_P_((char *device_name));
BOOLPARAM GRdevnum V_P_((char *device_name,  int *device_ordinal));
BOOLPARAM GRdevname V_P_((int device_ordinal,  char **device_name));

/* GR/GRdumprect.c */
BOOLPARAM GRdumprect V_P_((register DV_POINT *llp,  register DV_POINT *urp,
	 FILE *file));
BOOLPARAM GRdumpscreen V_P_((char *filename));

/* GR/GRlogplay.c */
BOOLPARAM GRlogplayback V_P_((FILE *logfile,  int device_map[]));

/* GR/GRlogxlate.c */
void GRexpand V_P_((FILE *binfile, FILE *asciifile));
void GRcompact V_P_((FILE *asciifile, FILE *binfile));

/* GR/GRpalette.c */
BOOLPARAM GRpaldraw V_P_((register RECTANGLE *palette_vp));
int GRpalpick V_P_((RECTANGLE *echovp, LONG *color_arg));
int GRpalfnpick V_P_((GRPALPICKFUNPTR fun,  RECTANGLE *echovp,
		      LONG *color_arg));
int GRpalpoll V_P_((LONG *color_arg));
void GRpalloc V_P_((DV_POINT *pt, LONG *color_arg));
BOOLPARAM GRpalcrmove V_P_((LONG color));
LONG GRpalhas_pt V_P_((DV_POINT *pt));

/* GR/GRplrvec.c */
BOOLPARAM GRplrvector V_P_((register DV_POINT *center,  PLR_POINT *p0,
	 PLR_POINT *p1));

/* GR/GRrqp.c */
int GRrqpprecision V_P_((int max_deviation));
int GRrqpsize V_P_((DV_POINT cp[3], float *k));
int GRrqppts V_P_((DV_POINT cp[3],  float *k,  register DV_POINT *ptbuf,
	 int bufsize));
void GRrqpdraw V_P_((DV_POINT cp[3],  float *k,  int linepattern,
	 int linewidth));
void GRrqpsplit V_P_((DV_POINT incp[3],  float *ink,  DV_POINT outcp1[3],
	 float *outk1,  DV_POINT outcp2[3],  float *outk2));

/***
*** 
***/




/* GR/GRprim.c */
BOOLPARAM GRmove V_P_((DV_POINT *p));
BOOLPARAM GRvector V_P_((DV_POINT *p));
BOOLPARAM GRconcat_vector V_P_((DV_POINT pt_list[], int num));
BOOLPARAM GRmove_and_vector V_P_((DV_POINT *p1, DV_POINT *p2));
BOOLPARAM GRrectangle V_P_((DV_POINT *p1, DV_POINT *p2));
BOOLPARAM GRf_rectangle V_P_((DV_POINT *p1, DV_POINT *p2));
BOOLPARAM GRcircle V_P_((DV_POINT *p, int radius));
BOOLPARAM GRf_circle V_P_((DV_POINT *p, int radius));
BOOLPARAM GRpolygon V_P_((DV_POINT pt_list[], int num));
BOOLPARAM GRf_polygon V_P_((DV_POINT pt_list[], int num));
BOOLPARAM GRsector V_P_((DV_POINT *p,  int radius,  int angle,  int delta));
BOOLPARAM GRf_sector V_P_((DV_POINT *p,  int radius,  int angle,
	 int delta));
BOOLPARAM GRerase V_P_((void));
BOOLPARAM GRdraw_background V_P_((RECTANGLE *svp));
BOOLPARAM GRline V_P_((DV_POINT *p, int type, int width));
BOOLPARAM GRmv_and_line V_P_((DV_POINT *p1,  DV_POINT *p2,  int type,
	 int width));
BOOLPARAM GRconcat_line V_P_((DV_POINT pt_list[],  int num,  int type,
	 int width));
BOOLPARAM GR_current_point V_P_((DV_POINT *p));
BOOLPARAM GRcur_point V_P_((DV_POINT *p));

/***
*** 
***/




/* GR/GRraster.c */
BOOLPARAM GRrasdraw V_P_((ADDRESS raster, DV_POINT *ll));
BOOLPARAM GRrasdrawpart V_P_((ADDRESS raster,  DV_POINT *ll,
	 RECTANGLE *portion));
BOOLPARAM GRrasget V_P_((DV_POINT *ll,  int width,  int height,
	 ADDRESS *raster));
BOOLPARAM GRrasfree V_P_((ADDRESS raster));
BOOLPARAM GRrasvalid V_P_((ADDRESS raster));
BOOLPARAM GRrasmove V_P_((DV_POINT *ll,  DV_POINT *ur,  DV_POINT *dest));
BOOLPARAM GRrasquery V_P_((int question));
BOOLPARAM GRrascreate V_P_((int width,  int height,  ADDRESS *raster));
BOOLPARAM GRrassize V_P_((ADDRESS raster,  int *width,  int *height,
	 int *depth));
BOOLPARAM GRrassave V_P_((ADDRESS raster, FILE *file));
BOOLPARAM GRrasrestore V_P_((FILE *file, ADDRESS *raster));
BOOLPARAM GRrasspix V_P_((ADDRESS raster,  DV_POINT *point,  LONG value));
LONG GRrasgpix V_P_((ADDRESS raster, DV_POINT *point));
BOOLPARAM GRrasspixels V_P_((ADDRESS raster,  ADDRESS values,
	 int value_unit));
BOOLPARAM GRrassmask V_P_((ADDRESS raster,  ADDRESS values));
BOOLPARAM GRrasspxrp V_P_((ADDRESS raster,  PIXREP *pPixrep,
	 COLOR_XFORM *xform));
BOOLPARAM GRrasgpxrp V_P_((PIXREP *pPixrep,  ADDRESS raster));
BOOLPARAM GRrassmaskpxrp V_P_((ADDRESS raster,  PIXREP *pPixrep,
	 COLOR_XFORM *pxform));

/***
*** 
***/




/* GR/GRtxtarray.c */
ADDRESS GRtaCreate V_P_((ULONG spec_flag,  DV_POINT *pt,
	 DV_POINT *szscr,  CHAR_POSITION *szchr,  int ch_ndx,  int *colors));
BOOLPARAM GRtaDestroy V_P_((ADDRESS ptap));
int GRtaGetWidth V_P_((ADDRESS tap));
int GRtaGetHeight V_P_((ADDRESS tap));
BOOLPARAM GRtaBox V_P_((ADDRESS ptap, RECTANGLE *r));
BOOLPARAM GRtaGetSize V_P_((ADDRESS tap, RECTANGLE *r));
BOOLPARAM GRtaGetDim V_P_((ADDRESS ptap, DV_POINT *p));
BOOLPARAM GRtaGetPosition V_P_((ADDRESS ptap,  DV_POINT *p,  int *row,
	 int *col));
BOOLPARAM GRtaGetCursorPosition V_P_((ADDRESS ptap,  int *row,
	 int *col));
BOOLPARAM GRtaShowCursor V_P_((ADDRESS ptap,  int makevisible));
BOOLPARAM GRtaMoveCursor V_P_((ADDRESS ptap,  int row,  int col));
BOOLPARAM GRtaWrite V_P_((ADDRESS ptap,  int row,  int col,  int ncols,
	 char *string,  int color));
BOOLPARAM GRtaWrtCells V_P_((register ADDRESS ptap,  int row,  int col,
	 register CHAR_CELL *cells,  int ncols));
BOOLPARAM GRtaGetCells V_P_((register ADDRESS ptap,  int row,  int col,
	 register CHAR_CELL *cells,  int ncols));
BOOLPARAM GRtaCharFill V_P_((register ADDRESS ptap,  CHAR_RECT *rect,
	 int chr,  int color));
BOOLPARAM GRtaSlide V_P_((register ADDRESS ptap,  CHAR_RECT *rect,
	 int direction,  int distance));
BOOLPARAM GRtaGetScreenVp V_P_((ADDRESS ptap,  CHAR_RECT *srectp,
	 RECTANGLE *vp));
BOOLPARAM GRtaGetString V_P_((ADDRESS ptap,  char *buf,  int bufsiz,
	 int frow,  int fcol,  int trow,  int tcol));
BOOLPARAM GRtaMove V_P_((ADDRESS ptap,  int xoff,  int yoff));
BOOLPARAM GRtaRefresh V_P_((ADDRESS ptap,  CHAR_RECT *crect));
void GRtaClip V_P_((ADDRESS tap,  RECTANGLE *invp,
	 RECTANGLE **outvps));

#define GRtaBeep() putchar('\07' /* BELL */);

/***
*** 
***/

/* GR/GRsftext.c */

BOOLPARAM GRgetsfont V_P_((ADDRESS curr_font, unsigned int *curr_tag ));
BOOLPARAM GRgetsfontinfo V_P_((ADDRESS req_fontid, ADDRESS *sfont_desc ));
BOOLPARAM GRsfontfree V_P_((ADDRESS font_id, unsigned int fonttag ));
ADDRESS GRsfontset V_P_((ADDRESS font_id, unsigned int *fonttag, 
                          ADDRESS sfont_desc ));
BOOLPARAM GRsftext V_P_((char *textp));
BOOLPARAM GRsfpt_to_scs(ADDRESS req_fontid, unsigned int tag, 
                        float *width, float *height);



/* GR/GRtext.c */
BOOLPARAM GRtext V_P_((char *textp));
BOOLPARAM GRtextsize V_P_((char *textp,  int *xsize,  int *ysize));
BOOLPARAM GRfont V_P_((int font_type));
BOOLPARAM GRch_size V_P_((int xsize, int ysize));
BOOLPARAM GRg_ch_size V_P_((int *xsize, int *ysize));

/***
*** 
***/




/* GR/GRvtext.c */
void GRgetvfontchar V_P_((int ch, register char *buf));
void GRvtext V_P_((UBYTE *str));
BOOLPARAM GRvfont V_P_((int nfont));
BOOLPARAM GRsavevfont V_P_((int nfont,  char *filename,  int format));
int GRvfontname V_P_((char *fontname));
void GRvtmatrix V_P_((register float tmatrix[2][2]));
void GRvspace V_P_((double charspace, double linespace));
BOOLPARAM GRfreevfont V_P_((int nfont));
void GRgetvnorm V_P_((int pixheight, float *normfactor));
void GRgetvspace V_P_((float *charspace,  float *linespace));
void GRgetvmaxwidth V_P_((UBYTE *instr, int *x, int *y));
BOOLPARAM GRgetvwidth V_P_((UBYTE *instr, int *x, int *y));
void GRgetvheight V_P_((int nlines, int *x, int *y));
char *GRgetvfontname V_P_((int nfont));
int GRgetvfont V_P_((void));



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* GRFUNDECL_H */



